# Sequence Form Linear Program

Implement the Sequence Form Linear Program. Your solution should work not just for the games you created in the first part of this assignment, but for any two-player zero-sum extensive form games.

## Hints

There are many ways to formulate the SQF program, but you might find it easiest to lean on Gurobi's modelling API, and implement the program as it was stated during the lecture.

To get `v(root)`, you can add up all the values at infosets reachable by the "empty" sequence.

Assign identifiers to actions, such that they are unique across infosets (Folding a royal flush is not equivalent to folding a high card, they must not both be named "fold.").

Gurobi can not handle variable names longer than 255 characters. 

By default, variables in gurobi are constrained. Use `lb=-GRB.INFINITY` and `ub=GRB.INFINITY` to create free variables.

Use `m.write("model.lp")` to inspect the model. Please test your solutions before uploading to BRUTE.

## Rules

You can use `Gurobi`, `cvxopt`, `numpy`, `scipy`, `pygambit`, and `cgt_bandits`.

Do not print anything but the payoffs to stdout, do not open, read or write to any files. The expected usage is: `python main.py < game.efg > out.txt`

Formulate the SQFs individually for both players.